<div ng-controller="synchronisationFormController as self"
     ng-init="self.init(
         <?= $this->authStorage()->getUser()->getId() ?>
         <?= $this->synchronisation ? ',' . $this->synchronisation->getId() : '' ?>
     )">
    <ul class="breadcrumb">
        <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
        <li><a href="<?= $this->url('timesheet') ?>"><?= $this->translate('time_module_title') ?></a></li>
        <li><a href="<?= $this->url('timesheet/synchronisation') ?>"><?= $this->translate('timesheet_nav_synchronisation') ?></a></li>
        <li class="active">
            <span ng-if="self.synchronisation.id">
                {{self.panelTitle}}
            </span>
            <span ng-if="!self.synchronisation.id">
                <?= $this->translate('timesheet_nav_form') ?>
            </span>
        </li>
    </ul>

    <h1 class="page-title">
        <?= $this->icon('refresh') ?> <?= $this->translate('timesheet_synchronisation_module_title') ?>
    </h1>

    <div class="row row-padding">
        <div class="col-xs-12">
            <div class="panel">
                <div class="panel-heading">
                    <span ng-if="self.synchronisation.id">
                        {{self.panelTitle}}
                    </span>
                    <span ng-if="!self.synchronisation.id">
                        <?= $this->translate('timesheet_synchronisation_nav_form') ?>
                    </span>

                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" ng-if="self.synchronisation.id && self.synchronisation._rights.delete" tooltip="<?= $this->translate('tooltip_delete') ?>">
                            <?= $this->icon('delete', 'pointer', ['ng-click' => 'self.deleteSynchronisation()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <form name="synchronisationForm" ng-submit="self.saveSynchronisation()">
                        <input type="hidden" name="id"   ng-model="self.synchronisation.id" />
                        <input type="hidden" name="user" ng-model="self.synchronisation.user" />

                        <div class="row">
                            <div class="form-group required col-sm-8 col-lg-8">
                                <label><?= $this->translate('timesheet_synchronisation_field_name') ?></label>
                                <input type="text"
                                       name="name"
                                       class="form-control"
                                       autocomplete="off"
                                       required
                                       ng-model="self.synchronisation.name"
                                       ng-readonly="!self.synchronisation._rights.update" />
                                <field-errors field="name" errors="self.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group required col-sm-8 col-lg-8">
                                <label><?= $this->translate('timesheet_synchronisation_field_link') ?></label>
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="fa fa-globe"></i>
                                    </span>
                                    <input type="text"
                                           name="link"
                                           required
                                           class="form-control"
                                           autocomplete="off"
                                           ng-model="self.synchronisation.link"
                                           ng-readonly="!self.synchronisation._rights.update" />
                                </div>
                                <field-errors field="link" errors="self.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group required col-sm-8 col-lg-8">
                                <label><?= $this->translate('timesheet_synchronisation_field_type') ?></label>
                                <select name="type"
                                        class="form-control"
                                        ng-model="self.synchronisation.type"
                                        ng-readonly="!self.synchronisation._rights.update"
                                        required>
                                    <?php foreach($this->syncTypes as $id => $type): ?>
                                    <option value="<?=$id;?>"><?= $this->translate($type); ?></option>
                                    <?php endforeach; ?>
                                </select>
                                <field-errors field="type" errors="self.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group col-sm-8 col-lg-8">
                                <label><?= $this->translate('timesheet_synchronisation_default_timezone'); ?> </label>
                                <select name="type"
                                        class="form-control"
                                        ng-model="self.synchronisation.timezone"
                                        ng-readonly="!self.synchronisation._rights.update">
                                    <?php foreach($this->timeZones as $id => $tz): ?>
                                    <option value="<?=$tz;?>"><?= $tz ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                        <div class="row">
                            <div class="form-group col-sm-8 col-lg-8">
                                <label><?= $this->translate('timesheet_synchronisation_default_descriptionMaxLength'); ?> </label>
                                <input type="text" 
                                class="form-control"
                                name="descriptionMaxLength"
                                ng-model="self.synchronisation.descriptionMaxLength" 
                                ng-readonly="!self.synchronisation._rights.update"/>
                            </div>
                        </div>

                        <div class="row" ng-if="self.synchronisation.type === '<?= \Time\Entity\Synchronisation::SYNC_TYPE_ZIMBRA_REST ?>'">
                            <div class="form-group required col-sm-4 col-lg-4">
                                <label><?= $this->translate('timesheet_synchronisation_zimbra_user') ?></label>
                                <input type="text"
                                       name="username"
                                       required
                                       class="form-control"
                                       autocomplete="off"
                                       ng-model="self.synchronisation.config.username"
                                       ng-readonly="!self.synchronisation._rights.update" />
                            </div>

                            <div class="form-group required col-sm-4 col-lg-4">
                                <label><?= $this->translate('timesheet_synchronisation_zimbra_password') ?></label>
                                <input type="password"
                                       name="password"
                                       required
                                       class="form-control"
                                       autocomplete="off"
                                       ng-model="self.synchronisation.config.password"
                                       ng-readonly="!self.synchronisation._rights.update" />
                            </div>
                        </div>
                        <div class="row">
                                <div class="form-group col-sm-8 col-lg-8">
                                    <label><?= $this->translate('timesheet_field_settings_time') ?></label>
                                    <settings-time-select name="settings-time" ng-model="self.synchronisation.settingsTime"></settings-time-select>
                                </div>
                        </div>
                        <div class="row">
                            <div class="form-group col-sm-4">
                                <label>
                                    <input type="checkbox" ng-model="self.synchronisation.parseTitle" ng-readonly="!self.account._rights.update"/>
                                    <?= $this->translate('synchronisation_field_parse_summary') ?>
                                </label>
                            </div>
                        </div>

                        <?php if($this->module()->isActive('project')): ?>
                        <fieldset>
                            <legend><?=$this->translate('timesheet_synchronisation_project_join')?></legend>
                            <div class="row">
                                <div class="form-group col-sm-8 col-lg-8">
                                    <label for="fieldToParse">
                                        <?= $this->translate('timesheet_synchronisation_field_field'); ?>
                                    </label>
                                    <select id="fieldToParse"
                                            name="fieldToParse"
                                            class="form-control"
                                            ng-model="self.synchronisation.config.field">
                                        <option value="0"><?= $this->translate('nothing'); ?></option>
                                        <?php foreach($this->configs['field'] as $id => $el): ?>
                                            <option value="<?=$id;?>">
                                                <?=$this->translate("timesheet_synchronisation_field_$el");?>
                                            </option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-sm-8 col-lg-8">
                                    <label for="closingChar">
                                        <?= $this->translate('timesheet_synchronisation_field_closing'); ?>
                                    </label>
                                    <select name="closingChar"
                                            id="closingChar"
                                            class="form-control"
                                            ng-model="self.synchronisation.config.closing">
                                        <option value="0"><?= $this->translate('nothing'); ?></option>
                                        <?php foreach($this->configs['closing'] as $id => $el): ?>
                                            <option value="<?=$id;?>">
                                                <?=$this->translate("timesheet_synchronisation_closing_$el");?>
                                            </option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-sm-4 col-lg-4">
                                    <label for="joinProject"><?= $this->translate('timesheet_synchronisation_field_join'); ?></label>
                                    <select class="form-control" id="joinProject" ng-model="self.synchronisation.config.join">
                                        <option value="0"><?= $this->translate('nothing'); ?></option>
                                        <?php foreach($this->configs['join'] as $id => $join): ?>
                                            <option value="<?=$id;?>">
                                                <?=$this->translate("timesheet_field_$join");?>
                                            </option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                                <div class="form-group col-sm-4 col-lg-4" ng-if="self.synchronisation.config.join == 'custom'">
                                    <label for="customField">
                                        <?= $this->translate('timesheet_field_custom'); ?>
                                    </label>
                                    <select class="form-control" id="customField" ng-model="self.synchronisation.config.custom">
                                        <option value="0"><?= $this->translate('nothing'); ?></option>
                                        <?php foreach($this->customs as $custom): ?>
                                            <option value="<?=$custom->getId() ?>">
                                                <?=$custom->getName() ?>
                                            </option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                            </div>
                        </fieldset>
                        <fieldset>
                            <legend><?=$this->translate('timesheet_synchronisation_cron')?></legend>
                            <div class="row">
                                <div class="form-group col-md-12">
                                    <label for="cronUsers">
                                        <?= $this->translate('timesheet_synchronisation_cron_users'); ?>
                                    </label>
                                    <user-select id="cronUsers" name="cronUsers" ng-model="self.synchronisation.cronUsers" multiple="true" required="false"></user-select>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-md-12">
                                    <label for="cronSchedule">
                                        <?= $this->translate('timesheet_synchronisation_cron_schedule'); ?>
                                    </label>

                                    <select id="cronSchedule" name="cronSchdule" ng-model="self.synchronisation.cronSchedule" required="false">
                                        <option ng-repeat="schedule in <?= str_replace('"', '\'', json_encode(\Time\Entity\Synchronisation::getSchedulerType()))?>"
                                                ng-value="schedule">
                                            {{ ('timesheet_synchronisation_cron_' + schedule) | translate }}
                                        </option>
                                    </select>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-md-12">
                                    <span ng-if="self.synchronisation.cronLastSync">
                                        <label><?= $this->translate('timesheet_synchronisation_cron_lastsync'); ?> : </label>
                                        {{self.synchronisation.cronLastSync | dateFormat : 'DD/MM/YYYY HH:mm'}}
                                    </span>
                                </div>
                            </div>
                        </fieldset>
                        <?php endif; ?>

                        <div ng-if="self.synchronisation._rights.update" class="row">
                            <div class="col-xs-12">
                                <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save" >
                                    <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                    <?= $this->translate('form_button_save') ?>
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('time:e:synchronisation:c')) {
    $fabLinks[] = [
        'href' => $this->url('timesheet/synchronisation/form'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('timesheet_synchronisation_nav_form'),
    ];
}

echo $this->fabMenu($fabLinks);

$this->angular('js/src/user/directive/userSelect.js');

$this->angular('js/src/time/service/synchronisation.js');
$this->angular('js/src/user/service/user.js');

$this->angular('js/src/time/controller/synchronisation/form.js');

$this->angular('js/src/time/service/settingsTime.js');
$this->angular('js/src/time/directive/settingsTimeSelect.js');

